routes/web.php
<?php

use App\Http\Controllers\CommentController;
use App\Http\Controllers\OfferController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\PostLikeController;
use App\Http\Controllers\StuffController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\UserProfileController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');


Route::group(['middleware' => ['auth']], function () {
    Route::resource('user', UserController::class);
    Route::get('user/{user}/delete', [UserController::class, 'destroy'])->name('user.delete');
});

Route::resource('post', PostController::class);

Route::get('user/{user:name}/profile', [UserProfileController::class, 'index'])->name('user.profile');

Route::get('post/{post}/delete', [PostController::class, 'destroy'])->name('post.delete');

Route::resource('offer', OfferController::class);

Route::resource('stuff', StuffController::class);

//Route::post('/post/{id}/likes', [PostLikeController::class, 'store'])->name('post.likes');
//Route::post('post/{post}/likes', [PostLikeController::class, 'destroy'])->name('post.delete');
Route::post('post/{post}/likes',[PostLikeController::class, 'store'])->name('post.likes');
Route::delete('post/{post}/likes',[PostLikeController::class, 'destroy'])->name('post.likes');

Route::resource('post/{post}/comment', CommentController::class);

//Route::post('post/{post}/comment',[CommentController::class, 'store'])->name('post.comment');


//Route::resource('offer', OfferController::class);

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

    protected $fillable = [
        'title',
        'body'
    ];

    public function adminPermission(User $user)
    {
        return $user->name == 'admin';
    }

    public function likes(){
        return $this->hasMany(Like::class);
    }

    public function liked(User $user){
        return $this->likes->contains('user_id', $user->id);
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use App\Models\Post;
use Illuminate\Http\Request;

class PostController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Http\Response
     */
    public function index()
    {
//        $posts = Post::where('body','666')->get();
        $posts = Post::all();
//        $posts = DB::table("posts")
//            ->select(...)
//            ->where(...);
        return view('post.index')->with('posts', $posts);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Http\Response
     */
    public function create()
    {


        return view('post.create', [
            'action' => route('post.store'),
            'method' => 'post'
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(Request $request)
    {
        $request->validate( [
            'body' => ['required', 'string'],
            'title' => ['required', 'string',  'max:100', 'min: 10'],
        ]);

        $post = Post::create($request->all());
        $post->save();
        return redirect()->route('post.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Http\Response
     */
    public function show(Post $post)
    {
//        $post = Post::find($id);
        return view('post.show')->with('post', $post);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\Foundation\Application|\Illuminate\Contracts\View\Factory|\Illuminate\Contracts\View\View|\Illuminate\Http\Response
     */
    public function edit(Post $post)
    {
        return view('post.edit',[
            'action'=>route('post.update', $post->id),
            'method'=>'put',
            'model'=>$post
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Request $request, Post $post)
    {
        $request->validate( [
            'body' => ['required', 'string'],
            'title' => ['required', 'string',  'max:100', 'min: 10'],
        ]);

        $post->update($request->all());
        return redirect()->route('post.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function destroy(Post $post)
    {
        $post->delete();
        return back();
    }
}

resources/views/post/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Add new user') }}</div>

                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif

                        @include('post.form');
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/post/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">{{ __('Edit') }}</div>

                    <div class="card-body">
                        @if (session('status'))
                            <div class="alert alert-success" role="alert">
                                {{ session('status') }}
                            </div>
                        @endif

                        @include('post.form');
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/post/form.blade.php
<div class="form-group text-danger">
    @foreach($errors->all() as $error)
        {{$error}} <br>
    @endforeach
</div>

<form method="post" action="{{ $action }}">
    @csrf
    @method($method)
    <div class="form-group">
        <label for="name">Titulok</label>
        <input type="text" class="form-control" id="title" name="title" value="{{ old('body', @$model->title) }}"
        >
    </div>

    <div class="form-group">
        <label for="exampleFormControlTextarea1">Popis</label>
        <textarea class="form-control" id="body" name="body" rows="3">{{ old('body', @$model->body) }}</textarea>
    </div>




    <div class="form-group">
        <input type="submit" class="btn-primary form-control">
    </div>
</form>

resources/views/post/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>
        @yield('title')
    </title>

    <link rel="stylesheet" href="{{ asset('css/post/index.css') }}">

    <!-- Additional per-page css -->
    @yield('css')
</head>

<body>

@yield('content')

<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
<script src="js/script.js"></script>
<script src="{{ asset('js/bootstrap.min.js') }}"></script>

<!-- Include per-page JS -->
@yield('js')
</body>

</html>

@extends('layouts.app')

@section('content')
    <div class="container">

        @if((auth()->user()->name) == 'admin')
            <div class="mb-4">
                <a href="{{ route('post.create') }}" class="btn btn-success" role="button">Pridat novy príspevokt</a>
            </div>
        @endif
    </div>
    @if(count($posts))
        @foreach($posts as $post)
            <div class="container">
                <div class="card text-white mb-3">
                    <img class="card-img"
                         src="https://scontent-vie1-1.xx.fbcdn.net/v/t1.0-9/139832331_2744794662426834_5937522858995968340_o.jpg?_nc_cat=100&ccb=2&_nc_sid=730e14&_nc_ohc=cb3YylgKI-UAX-o2eSy&_nc_ht=scontent-vie1-1.xx&oh=e9e95f08a92baa16886ed0f133a60333&oe=602A6DE9"
                         alt="Card image">
                    <div class="card-img-overlay">
                        <p class="date">{{$post->created_at->diffForHumans()}}</p>
                        <a href="{{ route('post.show', $post->id) }}" class="odkaz text-white"
                           title="Show">{{$post->title}}</a>
                        {{--                        <h1 class="card-title">{{$post->title}}</h1>--}}
{{--                        <p class="card-text">{{$post->body}}</p>--}}
                        <div class="like" id="wrapper">
                            <div class="likeButton" id="div1">
                                @if(!$post->liked(auth()->user()))
                                    <div id="first"></div>
                                    <form action="{{ route('post.likes', $post) }}" method="post">
                                        @csrf
                                        <button type="submit" class="btn btn-outline-success">Páči sa mi</button>
                                    </form>
                                @else
                                    <form action="{{ route('post.likes', $post) }}" method="post">
                                        @csrf
                                        @method('DELETE')

                                        <button type="submit" class="btn btn-outline-danger">Nepáči sa mi</button>
                                    </form>
                                @endif
                            </div>
                            <div class="likePocet" id="div2">
                                {{$post->likes->count()}} {{Str::plural('like',$post->likes->count())}}
                            </div>
                        </div>

                        {{--     <span>{{$post->likes->count()}} {{Str::plural('like',$post->likes->count())}} likes </span>--}}
                        {{--                        <p class="date">Last updated 3 mins ago</p>--}}
                    </div>
                </div>
                @if($post->adminPermission(auth()->user()))
                    <div>
                        <div class="tlacidlo" id="button1">
                            <form action="{{ route('post.destroy', $post) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button type="submit" class="btn btn-danger">Delete</button>
                            </form>
                        </div>
                        <div class="tlacidlo" id="button2">
                            <a href="{{ route('post.edit', $post) }}" title="Edit" class="btn btn btn-primary">Edit</a>
                        </div>
                    </div>
                @endif
            </div>
        @endforeach
    @else
        There are no posts
        @endif
        </div>
@endsection

resources/views/post/show.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>
        @yield('title')
    </title>

    <link rel="stylesheet" href="{{ asset('css/post/show.css') }}">

    <!-- Additional per-page css -->
    @yield('css')
</head>

<body>

@yield('content')

<script src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.4/jquery.min.js"></script>
<script src="js/script.js"></script>
<script src="{{ asset('js/bootstrap.min.js') }}"></script>

<!-- Include per-page JS -->
@yield('js')
</body>

</html>

@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="image">
            <img src="images/bmw_post.jpg">
        </div>

        <h1>{{$post->title}}</h1>
        <p>{{$post->body}}</p>
    </div>

@endsection